/*

 Copyright  2004, Birger N. Andreasen 
 Please send any bugreports, comments and other issues to:
 E-Mail = bna@post10.tele.dk
 Homepage with other ROTT stuff = http://home14.inet.tele.dk/Bna-Info

*/



//----------------------------------------------------------------------
// Windows Includes...
//----------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>
#include <dsound.h> 
#include "dxerr.h"
#include "dxerr.c"
#include "resource.h"  // Required for Win32 Resources
#include "develop.h"


#undef RELEASE
#ifdef __cplusplus
#define RELEASE(x) if (x != NULL) {x->Release(); x = NULL;}
#else
#define RELEASE(x) if (x != NULL) {x->lpVtbl->Release(x); x = NULL;}
#endif

//----------------------------------------------------------------------
// Direct Sound and Midi defines 
//----------------------------------------------------------------------

#define SB_SIZE       20480
#define NUM_DSBUFFERS 256

BOOL SetupDirectSound();
void ShutdownDirectSound(void);

LPDIRECTSOUND        lpds;
LPDIRECTSOUNDBUFFER  lpdsbPrimary;
LPDIRECTSOUNDBUFFER  lpdsbuffer[NUM_DSBUFFERS];

typedef enum { 
		midi_nofile, 
		midi_stop, 
		midi_play, 
		midi_pause 
} midi_state;

typedef struct {
    DWORD    MidiPosition;
    DWORD    MidiDevice;
    DWORD    MidiStatus;
    MCIERROR MidiError;
    char     szMidiFile[MAX_PATH];
}MIDI_Data_t;

BOOL  MidiPlay(HWND hWnd, MIDI_Data_t *mdd);
BOOL  MidiReplay(HWND hWnd, MIDI_Data_t *mdd);
BOOL  MidiPause(HWND hWnd, MIDI_Data_t *mdd);
BOOL  MidiResume(HWND hWnd, MIDI_Data_t *mdd);
void  MidiStop(MIDI_Data_t *mdd);
MIDI_Data_t MidiData;

//----------------------------------------------------------------------
// Windows #defines
//----------------------------------------------------------------------
#define SCREENWIDTH  640
#define SCREENHEIGHT 480


//----------------------------------------------------------------------
// Windows prototypes
//----------------------------------------------------------------------
extern int main (int argc, char *argv[]);

void    GetWindowsVersion(void);
void	WriteDebug(char *);
void	WriteLBtext(LPSTR txt);
void	ReadDelay(long delay);
int		PlayROTTMidiFile(char *song, boolean loop);
int		StopMidiMusic();
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL	PlayResource(LPSTR lpName) ;



extern int	MusicMode;
HINSTANCE	hInst;
HWND		hMainWnd;
HACCEL		ghAccel;
HWND		hWndList;
DWORD		dwCurrWidth, dwCurrHeight;
char		szAppName[] = "WinRott";
char		szDbgName[] = "WinRott.dbg";







//----------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
    MSG         msg;
    WNDCLASSEX  wc;
    HWND        hwnd;
    FILE        *fn,*stream;
    HACCEL      hAccel;
	HGDIOBJ		font;
    long        i;
	int			argc,linelen;
	char		*argv[40] ;
	char		*ptr;
	char		tmp[255];

    hInst = hInstance;

    fn = fopen(szDbgName, "w");
    fclose(fn);

    // current video setup data
    dwCurrWidth = GetSystemMetrics(SM_CXSCREEN);
    dwCurrHeight = GetSystemMetrics(SM_CYSCREEN);

  // Fill in window class structure with parameters that describe the main window.
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = CS_HREDRAW | CS_VREDRAW; // Class style(s).
    wc.lpfnWndProc   = (WNDPROC)WndProc;        // Window Procedure
    wc.cbClsExtra    = 0;                       // No per-class extra data.
    wc.cbWndExtra    = 0;                       // No per-window extra data.
    wc.hInstance     = hInstance;               // Owner of this class
    wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1)); // Icon name from .RC
    wc.hCursor       = LoadCursor(NULL, IDC_WAIT);
    wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1); // Default color
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = szAppName;               // Name to register as
	wc.hIconSm       = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));

    // Register the window class and return FALSE if unsuccesful.
    if (!RegisterClassEx(&wc))
    {
        //Assume we are running on NT where RegisterClassEx() is
        //not implemented, so let's try calling RegisterClass().
        if (!RegisterClass((LPWNDCLASS)&wc.style))
        	return FALSE;
    }
   
    // Create a main window for this application instance.
    hwnd = CreateWindow(szAppName,           // See RegisterClass() call
                        "WinRott",  // Text for window title bar
                        WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU, // Window styleWS_OVERLAPPEDWINDOW
                        CW_USEDEFAULT, CW_USEDEFAULT,	 // x, y
                        (dwCurrWidth/2)+6, (dwCurrHeight/2)+8,	 // cx, cy
                        NULL,                // Overlapped has no parent
                        NULL,                // Use the window class menu
                        hInstance,           // This instance owns this window
                        NULL                 // Don't need data in WM_CREATE
    );
    hMainWnd = hwnd;

	 hWndList = CreateWindowEx(
		  0L, "LISTBOX","",
		  LBS_NOTIFY | WS_BORDER | WS_VSCROLL | LBS_USETABSTOPS | WS_CHILD | WS_VISIBLE,
		  0, 0,
		  (dwCurrWidth/2), (dwCurrHeight/2),
		  (HWND)hwnd,
		  NULL,
		  hInstance,
		  NULL );

	 font = GetStockObject(ANSI_FIXED_FONT);
	 SendMessage(hWndList,WM_SETFONT, (UINT)font, 0L);



//	if (hWndList == NULL)
//		return NULL;

//	PlayResource("soundName");
    // Make the window visible & update its client area
    ShowWindow(hwnd, iCmdShow);// Show the window
    UpdateWindow(hwnd);        // Sends WM_PAINT message


//----CHECK wad	VERSION
#if (SHAREWARE)
	WriteLBtext("Starting WinRott version 1.00 SHAREWARE");
    //Open for read (will fail if file "huntbgin.wad" does not exist) 
    if( (stream  = fopen( "huntbgin.wad", "r" )) == NULL ){
		WriteLBtext("Error, Could not find HUNTBGIN.WAD, aborting game");
		goto Errexit;
	}else{
		fclose(stream);
		WriteLBtext("Found HUNTBGIN.WAD");
	}
#else
	WriteLBtext("Starting WinRott version 1.00 FULL VERSION");
    //Open for read (will fail if file "huntbgin.wad" does not exist) DARKWAR.WAD
    if( (stream  = fopen( "darkwar.wad", "r" )) == NULL ){
		WriteLBtext("Error, Could not find DARKWAR.WAD, aborting game");
		goto Errexit;
	}else{
		fclose(stream);
		WriteLBtext("Found DARKWAR.WAD");
	}
#endif

	if (szCmdLine[0] != 0){//only print if theres any parameters
		lstrcpy (tmp,"command line parameters = ");
		lstrcat (tmp,szCmdLine);	 
		WriteLBtext(tmp);
	}

	WriteLBtext("Use 'Winrott.exe -HELP' for help");    
	
	// This is used to determine what OS we're on (Windows9X or Windows NT)
    GetWindowsVersion();


	WriteLBtext("Converted to 640x480 by Birger N. Andreasen");
//  attemting to get DirectSound to work but failed
//  need to convert voc to wav
//	WriteLBtext("DirectSound conversion by Birger N. Andreasen");


//	WriteLBtext("Calling SetupDirectSound");
//  SetupDirectSound();


    ShowCursor(FALSE);

	//*****************************************
	// convert windows parameters to C standard 
	ptr = szCmdLine;
	argc = 1;//	argv[0],"WinRott.exe");
	linelen = lstrlen(szCmdLine);
	for (i=0;i<=linelen;i++){
		if (*(ptr+i) != ' ') {
			argv[argc++] = (ptr+i);
			//move to next arg
			do {
				i++;
			}while ((*(ptr+i) != ' ')&&(*(ptr+i) != 0));
			*(ptr+i) = 0;
		}
	}
	argv[argc] = 0;
	//*****************************************

	main(argc,argv); // jump to ROTT main loop

Errexit:;

//	WriteLBtext("Calling ShutdownDirectSound");
//    ShutdownDirectSound();

	WriteLBtext("");
	WriteLBtext("");

    ShowCursor(TRUE);

    hAccel = LoadAccelerators(hInstance, (LPCTSTR)IDR_ACCELERATOR1);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccel, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

    SendMessage(hMainWnd, WM_CLOSE, 0, 0);
	return msg.wParam;
}
//----------------------------------------------------------------------
void ReadDelay(long delay)
{
	//a delay so user has time to read text on screen
	unsigned long Tick = GetTickCount() + delay;
	do {
	}while(GetTickCount()<Tick);
}
//----------------------------------------------------------------------
void WriteLBtext(LPSTR txt)
{
	int slen;
	char buf[512];
	//remove garbage at txt_end
	lstrcpy(buf,txt);
	slen = lstrlen(buf);
	if (*(buf+slen-1)<=20){
		*(buf+slen-1)=0;
	}
	if (hWndList == NULL){return;}
	SendMessage(hWndList,LB_ADDSTRING , 0, (LPARAM)buf);
    UpdateWindow(hWndList);        // Sends WM_PAINT message
	ReadDelay(5);
}
//----------------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
    static HDC         hDC;
    static PAINTSTRUCT ps;
//    static event_t     event;
    static unsigned char KeyPress;
    static int         scancode;

    switch(iMsg)
	{
	case WM_CREATE:
		//GetCDInfo(hwnd);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case MM_MCINOTIFY:
		if (wParam == MCI_NOTIFY_SUCCESSFUL)
		{
			StopMidiMusic();
			PlayROTTMidiFile("rottsong.mid",1);
		}
		if (wParam == MCI_NOTIFY_FAILURE)
		{

		}
		break;
	}
    
	return DefWindowProc(hwnd, iMsg, wParam, lParam);
}
//----------------------------------------------------------------------
void WriteDebug(char *Message)
{
    FILE *fn;

    fn = fopen(szDbgName, "a+");
    fprintf(fn, "%s", Message);
    fclose(fn);
}
//----------------------------------------------------------------------
void GetWindowsVersion()
{
    OSVERSIONINFO OSVersionInfo;
    FILE *fn;
	char buf[512];

    fn = fopen(szDbgName, "a+");

    OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVersionInfo);
    GetVersionEx(&OSVersionInfo);

    switch(OSVersionInfo.dwPlatformId)
	{
	case VER_PLATFORM_WIN32s:
		sprintf(buf, "Platform is Windows %d.%02d\n",
			OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion);
		WriteLBtext(buf);
		fprintf(fn, "Platform is Windows %d.%02d\n",
			OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion);
		break;
	case VER_PLATFORM_WIN32_WINDOWS:
		fprintf(fn, "Platform is Windows 9X ");
		sprintf(buf, "Platform is Windows 9X ,Version %d.%02d.%d\n", OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion,
			OSVersionInfo.dwBuildNumber & 0xFFFF);
		WriteLBtext(buf);
		fprintf(fn, "Version %d.%02d.%d\n", OSVersionInfo.dwMajorVersion,
			OSVersionInfo.dwMinorVersion,
			OSVersionInfo.dwBuildNumber & 0xFFFF);
		break;
	case VER_PLATFORM_WIN32_NT:
		sprintf(buf, "Platform is Windows NT ,Version %d.%02d ", OSVersionInfo.dwMajorVersion, OSVersionInfo.dwMinorVersion);
		WriteLBtext(buf);		
		sprintf(buf, "Build %d\n", OSVersionInfo.dwBuildNumber & 0xFFFF);
		WriteLBtext(buf);

		fprintf(fn, "Platform is Windows NT ");
		fprintf(fn, "Version %d.%02d ", OSVersionInfo.dwMajorVersion, OSVersionInfo.dwMinorVersion);
		fprintf(fn, "Build %d\n", OSVersionInfo.dwBuildNumber & 0xFFFF);
		break;
	}
    if(strlen(OSVersionInfo.szCSDVersion) > 0)
		fprintf(fn, "Windows Info: %s\n", OSVersionInfo.szCSDVersion);
    fclose(fn);
}


//----------------------------------------------------------------------
// DIRECTSOUND - Sound effects
//----------------------------------------------------------------------

BOOL SetupDirectSound()
   {
    HRESULT        hresult;
    int            buff;
    DSBUFFERDESC   dsbdesc;
    WAVEFORMATEX   wfx;

    // Create an instance of DirectSound
    hresult = DirectSoundCreate(NULL, &lpds, NULL);
    if (hresult != DS_OK)
       {
        DS_Error(hresult, "DirectSoundCreate");
        for (buff = 0; buff < NUM_DSBUFFERS; buff++)
           lpdsbuffer[buff] = 0;
        return FALSE;
       }

    // Set the cooperative level so it doesn't get confused
    hresult = lpds->lpVtbl->SetCooperativeLevel(lpds, hMainWnd, DSSCL_EXCLUSIVE);
    if (hresult != DS_OK)
       DS_Error(hresult, "DirectSound.SetCooperativeLevel");

    // Set up DSBUFFERDESC structure.
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));  // Zero it out.
    dsbdesc.dwSize              = sizeof(DSBUFFERDESC);
    dsbdesc.dwFlags             = DSBCAPS_PRIMARYBUFFER;
    dsbdesc.dwBufferBytes       = 0;
    dsbdesc.lpwfxFormat         = NULL;

    hresult = lpds->lpVtbl->CreateSoundBuffer(lpds, &dsbdesc, &lpdsbPrimary, NULL);
    if (hresult != DS_OK)
       {
        DS_Error(hresult, "DirectSound.CreateSoundBuffer - Primary");
       }

    // Set up wave format structure.
    memset( &wfx, 0, sizeof(WAVEFORMATEX) );
    wfx.wFormatTag         = WAVE_FORMAT_PCM;      
    wfx.nChannels          = 2;
    wfx.nSamplesPerSec     = 11025;
    wfx.nAvgBytesPerSec    = 11025*2*1;
    wfx.nBlockAlign        = 2; // ?
    wfx.wBitsPerSample     = (WORD)8;
    wfx.cbSize             = 0;

    hresult = lpdsbPrimary->lpVtbl->SetFormat(lpdsbPrimary, &wfx);
    if (hresult != DS_OK)
       {
        DS_Error(hresult, "DirectSound.SetFormat - Primary");
       }

    // Set the cooperative level so it doesn't get confused
    hresult = lpds->lpVtbl->SetCooperativeLevel(lpds, hMainWnd, DSSCL_NORMAL);
    if (hresult != DS_OK)
       DS_Error(hresult, "DirectSound.SetCooperativeLevel");

    return(TRUE);
   }

//#define DSBCAPS_CTRLDEFAULT 224;
void CreateSoundBuffer(int Channel, int length, unsigned char *data)
   {
    HRESULT        hresult;
    //int            buff;
    DSBUFFERDESC   dsbdesc;
    PCMWAVEFORMAT  pcmwf;
    void          *buffer, *buff2;
    DWORD          size1, size2;

    if (Channel > NUM_DSBUFFERS)
       {
        WriteDebug("Invalid sound effect...\n");
        return;
       }

    // Set up wave format structure.
    memset( &pcmwf, 0, sizeof(PCMWAVEFORMAT) );
    pcmwf.wf.wFormatTag         = WAVE_FORMAT_PCM;      
    pcmwf.wf.nChannels          = 1;
    pcmwf.wf.nSamplesPerSec     = 11025;
    pcmwf.wf.nBlockAlign        = 1; // ?
    pcmwf.wf.nAvgBytesPerSec    = 11025*1*1;
    pcmwf.wBitsPerSample        = (WORD)8;

    // Set up DSBUFFERDESC structure.
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));  // Zero it out.
    dsbdesc.dwSize              = sizeof(DSBUFFERDESC);
    dsbdesc.dwFlags             = DSBCAPS_CTRLDEFAULT|DSBCAPS_CTRLPOSITIONNOTIFY;
    dsbdesc.dwBufferBytes       = length;
    dsbdesc.lpwfxFormat         = (LPWAVEFORMATEX)&pcmwf;

    if ((hresult = lpds->lpVtbl->CreateSoundBuffer(lpds, &dsbdesc, &lpdsbuffer[Channel], NULL)) != DS_OK)
       {
        DS_Error(hresult, "DirectSound.CreateSoundBuffer");
        return;
       }

    hresult = lpdsbuffer[Channel]->lpVtbl->Lock(lpdsbuffer[Channel],0,length,&buffer,&size1,&buff2,&size2,DSBLOCK_ENTIREBUFFER );
    if (hresult == DS_OK)
       {
        memcpy(buffer, data, length);
        hresult = lpdsbuffer[Channel]->lpVtbl->Unlock(lpdsbuffer[Channel],buffer,length,buff2,size2);
        if (hresult != DS_OK){
           DS_Error(hresult, "lpdsbuffer.Unlock");
		}
       }
    else
       {
        DS_Error(hresult, "lpdsbuffer.Lock");
       }
   }

void ShutdownDirectSound(void)
{
    int buff;
    DWORD BufferStatus;

    for(buff = 0; buff < NUM_DSBUFFERS; buff++)
	{
        if(lpdsbuffer[buff] != 0)
		{
            BufferStatus = DSBSTATUS_PLAYING;
            while (BufferStatus == DSBSTATUS_PLAYING)
                lpdsbuffer[buff]->lpVtbl->GetStatus(lpdsbuffer[buff], &BufferStatus);
            RELEASE(lpdsbuffer[buff]);
		}
	}
    if(lpdsbPrimary != NULL) RELEASE(lpdsbPrimary);
    if(lpds != NULL) RELEASE(lpds);
}

//----------------------------------------------------------------------
//
//----------------------------------------------------------------------


BOOL PlayResource(LPSTR lpName) 
{
	BOOL bRtn;     
	LPSTR lpRes; 
    HANDLE hResInfo,hRes;      // Find the WAVE resource.  
    
	hResInfo = FindResource(hInst, lpName, "WAVE");     
	if (hResInfo == NULL) 
        return FALSE;      // Load the WAVE resource.  
    hRes = LoadResource(hInst, hResInfo);     
	if (hRes == NULL) 
        return FALSE;      // Lock the WAVE resource and play it.  
    lpRes = LockResource(hRes);   

	if (lpRes != NULL) { 
        bRtn = sndPlaySound(lpRes, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);         
		UnlockResource(hRes);     
	}     
	else 
        bRtn = 0;      // Free the WAVE resource and return success or failure. 
     FreeResource(hRes);     
	 return bRtn; 
} 
//----------------------------------------------------------------------
BOOL PlayMemSound(char *memptr) 
{  
	int i;
	BOOL bRtn;     
	LPSTR lpRes,lpMem; 
    HANDLE hResInfo,hRes;      // Find the WAVE resource.  
    
	hResInfo = FindResource(hInst, "soundName", "WAVE");     
	if (hResInfo == NULL) 
        return FALSE;      // Load the WAVE resource.  
    hRes = LoadResource(hInst, hResInfo);     
	if (hRes == NULL) 
        return FALSE;      // Lock the WAVE resource and play it.  
    lpRes = LockResource(hRes);  
	
	lpMem = lpRes + 0x2C;
	//copy ptr data tp lpRes
	for (i=0;i<3600;i++){
		*lpMem++ = *memptr++;
	}

	if (lpRes != NULL) { 
        bRtn = sndPlaySound(lpRes, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);         
		UnlockResource(hRes);     }     
	else 
        bRtn = 0;      // Free the WAVE resource and return success or failure. 
     FreeResource(hRes);     
	 return bRtn; 
}



// some of next sections code is stolen from windoom by Bruce A. Lewis.
HWND hWndsound;
// Local define needed only for error message capture and display
#define     MCIMSGLEN  128
char        MidiMsg[MCIMSGLEN+1];


BOOL MidiPlay(HWND hWnd, MIDI_Data_t *mdd)
{
    MCI_OPEN_PARMS     open;
    MCI_PLAY_PARMS     play;
    MCIERROR           MCI_Error;
    UINT               uDeviceId;

    hWndsound = hWnd;

	if (access(mdd->szMidiFile, 4) != 0)
	{
        mdd->MidiStatus = midi_nofile;
        return(FALSE);
	}

    open.dwCallback       = (DWORD)hWnd;
    open.lpstrDeviceType  = "sequencer";
    open.lpstrElementName = mdd->szMidiFile;

    MCI_Error = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)&open);

    if (MCI_Error)
	{
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mdd->MidiError = MCI_Error;
        return(FALSE);
	}

    // play back midi file
    //......................
	uDeviceId = open.wDeviceID;
    play.dwCallback = (DWORD)hWnd;
                           
    MCI_Error = mciSendCommand(uDeviceId, MCI_PLAY, MCI_NOTIFY, (DWORD)&play);
    if (MCI_Error)
	{
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mciSendCommand(uDeviceId, MCI_CLOSE, 0, (DWORD)NULL);
        mdd->MidiError = MCI_Error;
        return(FALSE);
	}
    mdd->MidiDevice = uDeviceId;
    mdd->MidiStatus = midi_play;

	

    return(TRUE);
}  //midiplay

BOOL MidiReplay(HWND hWnd, MIDI_Data_t *mdd)
   {
    MCI_PLAY_PARMS     play;
    MCIERROR           MCI_Error;

    play.dwCallback = (DWORD)hWnd;
    play.dwFrom = 0;
                           
    MCI_Error = mciSendCommand(mdd->MidiDevice, MCI_PLAY, MCI_NOTIFY | MCI_FROM, (DWORD)&play);
    if (MCI_Error)
       {
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        return(FALSE);
       }
    return(TRUE);
   }

BOOL MidiPause(HWND hWnd, MIDI_Data_t *mdd)
   {
    MCI_SET_PARMS      set;
    MCI_STATUS_PARMS   status;
    MCIERROR           MCI_Error;

    mdd->MidiError = 0;
    set.dwTimeFormat   = MCI_FORMAT_MILLISECONDS;
    mciSendCommand(mdd->MidiDevice, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)(LPVOID)&set);

    status.dwCallback  = (DWORD)hWnd;
    status.dwItem = MCI_STATUS_POSITION;

    MCI_Error = mciSendCommand(mdd->MidiDevice, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)&status);
    if (MCI_Error)
       {
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        strcat(MidiMsg, "\nMidiPause");
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mdd->MidiError = MCI_Error;
        return(FALSE);
       }
    mdd->MidiPosition = status.dwReturn;
    mciSendCommand(mdd->MidiDevice, MCI_STOP, 0, (DWORD)NULL);
    mdd->MidiStatus = midi_pause;
    return(TRUE);
   }

BOOL MidiResume(HWND hWnd, MIDI_Data_t *mdd)
   {
    MCI_SET_PARMS      set;
    MCI_PLAY_PARMS     play;
    MCIERROR           MCI_Error;

    mdd->MidiError = 0;
    set.dwTimeFormat   = MCI_FORMAT_MILLISECONDS;
    mciSendCommand(mdd->MidiDevice, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)(LPVOID) &set);

    play.dwCallback = (DWORD)hWnd;
    play.dwTo = 0;
    play.dwFrom = mdd->MidiPosition;
    MCI_Error = mciSendCommand(mdd->MidiDevice, MCI_PLAY, MCI_NOTIFY | MCI_FROM, (DWORD)(LPVOID)&play);
    if (MCI_Error)
       {
        mciGetErrorString(MCI_Error, MidiMsg, MCIMSGLEN);
        strcat(MidiMsg, "\nMidiResume");
        MessageBox(hWnd, MidiMsg, NULL, MB_ICONSTOP | MB_OK);
        mdd->MidiError = MCI_Error;
        return(FALSE);
       }
    mdd->MidiStatus = midi_play;
    return(TRUE);
   }

void MidiStop(MIDI_Data_t *mdd)
   {
    mciSendCommand(mdd->MidiDevice, MCI_STOP, 0, (DWORD)NULL);
    mciSendCommand(mdd->MidiDevice, MCI_CLOSE, 0, (DWORD)NULL);
    mdd->MidiStatus = midi_stop;
   }



int PlayROTTMidiFile(char *song, boolean loop)
{
	strcpy(MidiData.szMidiFile, song);
    MidiPlay(hMainWnd, &MidiData);
	return 0;
}


void PlayMidiMusic()
   {

    if ((MidiData.MidiStatus != midi_play) && (MidiData.MidiStatus != midi_pause))
       {
        MidiPlay(hMainWnd, &MidiData);
       }
   }


void PauseResumeMusic()
   {
    switch(MidiData.MidiStatus)
       {
        case midi_play:
             MidiPause(hMainWnd, &MidiData);
             break;
        case midi_pause:
             MidiResume(hMainWnd, &MidiData);
             break;
       }
  
   }

int StopMidiMusic()
{
    if(MidiData.MidiStatus != midi_stop)
	{
        MidiStop(&MidiData);
	}
	return 0;
}



long GetSetVolumeMidi (long newvol, int SetGetFLAG) // 0 = get  1 = set
{	
	// return = actuell midi value by get 
	int SoundScale = 255;

    MMRESULT rc;              // Return code.
    HMIXER hMixer;            // Mixer handle used in mixer API calls.
    MIXERCONTROL mxc;         // Holds the mixer control data.
    MIXERLINE mxl;            // Holds the mixer line data.
    MIXERLINECONTROLS mxlc;   // Obtains the mixer control.
	MIXERCONTROLDETAILS mxcd;             // Gets the control values.
    MIXERCONTROLDETAILS_SIGNED volStruct; // Gets the control values.
	long volume;                          // Holds the final volume value.

	// Open the mixer. This opens the mixer with a deviceID of 0. If you
    // have a single sound card/mixer, then this will open it. If you have
    // multiple sound cards/mixers, the deviceIDs will be 0, 1, 2, and
    // so on.    
	rc = mixerOpen(&hMixer, 0,0,0,0);
    if (MMSYSERR_NOERROR == rc) {        
		// Couldn't open the mixer. 
		//return 0;
	}

    // Initialize MIXERLINE structure.    
	ZeroMemory(&mxl,sizeof(mxl));
    mxl.cbStruct = sizeof(mxl);

    // Specify the line you want to get. You are getting the input line
    // here. If you want to get the output line, you need to use
    // MIXERLINE_COMPONENTTYPE_SRC_MIDIOUT.= 4100 = midi value
    mxl.dwComponentType = 4100;//MIXERLINE_COMPONENTTYPE_DST_WAVEIN;

    rc = mixerGetLineInfo((HMIXEROBJ)hMixer, &mxl,MIXER_GETLINEINFOF_COMPONENTTYPE);
    if (MMSYSERR_NOERROR == rc) {        
		// Couldn't get the mixer line. 
		//return 0;
	}

	// Get the control.    
	ZeroMemory(&mxlc, sizeof(mxlc));
    mxlc.cbStruct = sizeof(mxlc);    
	mxlc.dwLineID = mxl.dwLineID;
    mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME;
    mxlc.cControls = 1;    
	mxlc.cbmxctrl = sizeof(mxc);   
	mxlc.pamxctrl = &mxc;
    ZeroMemory(&mxc, sizeof(mxc));    
	mxc.cbStruct = sizeof(mxc);
    rc = mixerGetLineControls((HMIXEROBJ)hMixer,&mxlc,MIXER_GETLINECONTROLSF_ONEBYTYPE);
    if (MMSYSERR_NOERROR == rc) {   
		// Couldn't get the control.
		//mixerClose(hMixer);
		//return 0;
	}
    // After successfully getting the dwControlType control, the volume range
    // will be specified by mxc.Bounds.lMinimum to mxc.Bounds.lMaximum.


	if (SetGetFLAG == 0) {  // caller wants a actuel sound value
		// Initialize the MIXERCONTROLDETAILS structure
		ZeroMemory(&mxcd, sizeof(mxcd));    
		mxcd.cbStruct = sizeof(mxcd);
		mxcd.cbDetails = sizeof(volStruct);    
		mxcd.dwControlID = mxc.dwControlID;
		mxcd.paDetails = &volStruct;   
		mxcd.cChannels = 1;
		// Get the current value of the dwControlType control. 
		rc = mixerGetControlDetails((HMIXEROBJ)hMixer, &mxcd,
                                 MIXER_GETCONTROLDETAILSF_VALUE);
		if (MMSYSERR_NOERROR == rc) {        
			// Couldn't get the current volume.
			//mixerClose(hMixer);
			//return 0;

	    }    
		volume = volStruct.lValue;    // Get the absolute value of the volume.
		if (volume < 0)        
			volume = -volume;
		mixerClose(hMixer);
		return (volume/SoundScale);
	}
	if (SetGetFLAG == 1) {  // caller wants to set sound value
	    // Initialize the MIXERCONTROLDETAILS structure
		ZeroMemory(&mxcd, sizeof(mxcd));    
		mxcd.cbStruct = sizeof(mxcd);
		mxcd.cbDetails = sizeof(volStruct);    
		mxcd.dwControlID = mxc.dwControlID;
		mxcd.paDetails = &volStruct;   
		mxcd.cChannels = 1;
		volStruct.lValue = (newvol*SoundScale);
		rc = mixerSetControlDetails((HMIXEROBJ)hMixer, &mxcd,
                                 MIXER_GETCONTROLDETAILSF_VALUE);

	}	
	
	mixerClose(hMixer);
	return 0;
	
}


/* unused bna++
// Plays a specified MIDI file by using MCI_OPEN and MCI_PLAY. Returns 
// as soon as playback begins. The window procedure function for the 
// specified window will be notified when playback is complete. 
// Returns 0L on success; otherwise, it returns an MCI error code.

DWORD playMIDIFile(HWND hWndNotify, LPSTR lpszMIDIFileName)
{
    UINT wDeviceID;
    DWORD dwReturn;
    MCI_OPEN_PARMS mciOpenParms;
    MCI_PLAY_PARMS mciPlayParms;
    MCI_STATUS_PARMS mciStatusParms;
    MCI_SEQ_SET_PARMS mciSeqSetParms;

    // Open the device by specifying the device and filename.
    // MCI will attempt to choose the MIDI mapper as the output port.
    mciOpenParms.lpstrDeviceType = "sequencer";
    mciOpenParms.lpstrElementName = lpszMIDIFileName;
    if (dwReturn = mciSendCommand(NULL, MCI_OPEN,
        MCI_OPEN_TYPE | MCI_OPEN_ELEMENT,
        (DWORD)(LPVOID) &mciOpenParms))
    {
        // Failed to open device. Don't close it; just return error.
        return (dwReturn);
    }

    // The device opened successfully; get the device ID.
    wDeviceID = mciOpenParms.wDeviceID;

    // Check if the output port is the MIDI mapper.
    mciStatusParms.dwItem = MCI_SEQ_STATUS_PORT;
    if (dwReturn = mciSendCommand(wDeviceID, MCI_STATUS, 
        MCI_STATUS_ITEM, (DWORD)(LPVOID) &mciStatusParms))
    {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return (dwReturn);
    }

    // The output port is not the MIDI mapper. 
    // Ask if the user wants to continue.
    if (LOWORD(mciStatusParms.dwReturn) != MIDI_MAPPER)
    {
        if (MessageBox(hMainWnd,
            "The MIDI mapper is not available. Continue?",
            "", MB_YESNO) == IDNO)
        {
            // User does not want to continue. Not an error;
            // just close the device and return.
            mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
            return (0L);
        }
    }

    // Begin playback. The window procedure function for the parent 
    // window will be notified with an MM_MCINOTIFY message when 
    // playback is complete. At this time, the window procedure closes 
    // the device.
    mciPlayParms.dwCallback = (DWORD) hWndNotify;
    if (dwReturn = mciSendCommand(wDeviceID, MCI_PLAY, MCI_NOTIFY, 
        (DWORD)(LPVOID) &mciPlayParms))
    {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return (dwReturn);
    }

    return (0L);
}
*/ 

/* unused bna
// Plays a specified waveform-audio file using MCI_OPEN and MCI_PLAY. 
// Returns when playback begins. Returns 0L on success, otherwise 
// returns an MCI error code.
DWORD playWAVEFile(HWND hWndNotify, LPSTR lpszWAVEFileName)
{   
	UINT wDeviceID;
    DWORD dwReturn;    
	MCI_OPEN_PARMS mciOpenParms;
    MCI_PLAY_PARMS mciPlayParms;
    // Open the device by specifying the device and filename.
    // MCI will choose a device capable of playing the specified file.
    mciOpenParms.lpstrDeviceType = "waveaudio";
    mciOpenParms.lpstrElementName = lpszWAVEFileName;
    if (dwReturn = mciSendCommand(0, MCI_OPEN,
       MCI_OPEN_TYPE | MCI_OPEN_ELEMENT,        
	   (DWORD)(LPVOID) &mciOpenParms))
    {        
		// Failed to open device. Don't close it; just return error.
        return (dwReturn);    
	}
    // The device opened successfully; get the device ID.
    wDeviceID = mciOpenParms.wDeviceID;
    // Begin playback. The window procedure function for the parent 
    // window will be notified with an MM_MCINOTIFY message when 
    // playback is complete. At this time, the window procedure closes 
    // the device.    mciPlayParms.dwCallback = (DWORD) hWndNotify;
    if (dwReturn = mciSendCommand(wDeviceID, MCI_PLAY, MCI_NOTIFY, 
        (DWORD)(LPVOID) &mciPlayParms))    {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);        
		return (dwReturn);
    }    
	return (0L);
}
*/










